Index: /trunk/SophyaPI/PI/piimage.cc
===================================================================
--- /trunk/SophyaPI/PI/piimage.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/piimage.cc	(revision 4077)
@@ -111,6 +111,4 @@
 gvw = NULL;   // widget vue globale
 cmvw = NULL;  // widget ColorMapView
-fgshowcmap = 0;  // 0: Pas de vue ColMap, 1: top, 2:right,  3:bottom, 4:left
- cmdid = -1;
 // Fenetre transient et Label pour affichage de l'info (texte PixVal)
 int tx, ty;
@@ -130,4 +128,7 @@
 cutscw = NULL; 
 
+gpixm = zpixm = pixm = NULL;
+xsgpxm = xszpxm = xspxm = 0;
+ysgpxm = yszpxm = yspxm = 0;
 lut = NULL; 
 offx = offy = 0;
@@ -144,5 +145,5 @@
 
 mdrw = new PIElDrawer(false);
-mdrw->SetAxesFlags(kAxesNone);
+ mdrw->SetAxesFlags(kAxesNone);
 gvdrw = new PIElDrawer();
 AddDrawer(mdrw, true, false, false, false);
@@ -173,12 +174,15 @@
 PIImage::~PIImage()
 {
+if (pixm) delete pixm;
+if (zpixm) delete zpixm;
 if (zow) 
   {
-  zow->SetPixmap(NULL);
+  zow->SetPixmap(NULL,0,0);
   zow->EraseWindow();
   }
+if (gpixm) delete gpixm;
 if (gvw) 
   {
-  gvw->SetPixmap(NULL);
+  gvw->SetPixmap(NULL,0,0);
   gvw->EraseWindow();
   gvw->SetMsg(0); gvw->SetMsgParent(NULL); 
@@ -252,5 +256,7 @@
 xszpav = yszpav = 1;
 img = pim;
-gpixm.DeAlloc();
+if (gpixm) delete gpixm;
+gpixm = NULL;
+xsgpxm = ysgpxm = 0;
 zmgv = 1;
 
@@ -601,13 +607,7 @@
     // Position du centre d'image
     if (opts.substr(0,12) == "imagecenter=") {
-      /* Si on ecrit "imagecenter=34.5,55.5" ca ne marche pas CMV 29/01/2011
-      int xc = XPave(), yc = YPave();
+      int xc = XPave();  
+      int yc = YPave();
       sscanf(opts.substr(12).c_str(),"%d,%d",&xc, &yc);
-      SetPave(xc, yc, false, true);
-      */
-      int xc = XPave(), yc = YPave();
-      double ddxc = xc, ddyc = yc;
-      sscanf(opts.substr(12).c_str(),"%lf,%lf",&ddxc, &ddyc);
-      xc = int(ddxc+0.00001); yc = int(ddyc+0.00001); 
       SetPave(xc, yc, false, true);
       continue;
@@ -633,18 +633,12 @@
       double min = Lut()->Min();
       double max = Lut()->Max();
+      size_t q = opts.find(',');
+      if (q < opts.length()-1)
+	sscanf(opts.substr(q+1).c_str(),"%lg,%lg",&min, &max);
       int typlut=kLutType_Lin;      ;
       if (opts.substr(4,3) == "lin")  typlut=kLutType_Lin;
       else if (opts.substr(4,3) == "log")  typlut=kLutType_Log;
-      else if (opts.substr(4,3) == "exp")  typlut=kLutType_Exp;
       else if (opts.substr(4,4) == "sqrt")  typlut=kLutType_Sqrt;
       else if (opts.substr(4,6) == "square")  typlut=kLutType_Square;
-      else if (opts.substr(4,3) == "rgb")  { 
-        typlut=kLutType_RGB;
-        min = 0;  max = 255;
-      } 
-      size_t q = opts.find(',');
-      if (q < opts.length()-1)
-	sscanf(opts.substr(q+1).c_str(),"%lg,%lg",&min, &max);
-
       SetLut(AutoLut_No, min, max, typlut, 0, false);
       continue;
@@ -674,24 +668,9 @@
       continue;
     }
-    if (opts == "showcmap")  UpdateCMapDrawer(1);
-    else if (opts == "noshowcmap")  UpdateCMapDrawer(0);
-    else if (opts.substr(0,9) == "showcmap=") {
-      if (opts.substr(9,2) == "no")   UpdateCMapDrawer(0); 
-      else if (opts.substr(9,3) == "top")     UpdateCMapDrawer(1); 
-      else if (opts.substr(9,5) == "right")   UpdateCMapDrawer(2); 
-      else if (opts.substr(9,6) == "bottom")  UpdateCMapDrawer(3); 
-      else if (opts.substr(9,4) == "left")    UpdateCMapDrawer(4); 
-      else if (opts.substr(9,5) == "horiz")   UpdateCMapDrawer(1); 
-      else if (opts.substr(9,4) == "vert")    UpdateCMapDrawer(2); 
-      else UpdateCMapDrawer(0); 
-    }
-
     ndec--;
     udopt.push_back(opts);
   }
   // Set color map if requested
-  if(fgcmapid || revcmapid) 
-    SetColMapId(cmapid,revcmapid,false);  
-
+  if(fgcmapid || revcmapid) SetColMapId(cmapid,revcmapid,false);
   // Configure axes if requested 
   if (confaxes) ChangeAxesConfiguration(invx, invy, exchxy, false);
@@ -712,5 +691,4 @@
       SetLut(t_al, min_al, max_al, Lut()->Type(), ns_al, false);
   }
-
   return(ndec+ndec2);
 }
@@ -746,27 +724,13 @@
 {
 if (!cmp)  return;
-int ncolold = 0;
-if (cmap) ncolold = cmap->NCol();
-bool fgapp = false;
-if (refr && cmp->NCol() != ncolold) {
-  fgapp = true;  refr = false;
-}
 int cmapid = cmp->Type();
 if ( (cmapid == CMAP_GREY32) || (cmapid == CMAP_GREYINV32) || 
      (cmapid == CMAP_GREY128) || (cmapid == CMAP_GREYINV128))  mdrw->GetGraphicAtt().SetColAtt(PI_Red);
 else mdrw->GetGraphicAtt().SetColAtt(PI_Turquoise);
-if (lut) lut->SetNCol(cmp->NCol());
 PIPixmap::SetColMap(cmp, refr);
 if (refr) { xcurs =  ycurs = -1; }
 if (zow)  zow->SetColMap(cmp, refr);
-if (gvw)  { 
-    if (cmap->NCol() != ncolold) { 
-    ComputeGloVPixmap();
-    SetGloVPixmap();
-  }
-  else  gvw->SetColMap(cmp, refr);
-}
+if (gvw)  gvw->SetColMap(cmp, refr);
 if (cmvw) cmvw->SetColMap(cmap, Lut()->Min(), Lut()->Max(), refr);
-if (fgapp)  Apply();
 return;
 }
@@ -775,27 +739,11 @@
 void PIImage::SetColMapId(CMapId cmapid, bool revidx, bool refr)
 {
-int ncolold = 0;
-if (cmap) ncolold = cmap->NCol();
 if ( (cmapid == CMAP_GREY32) || (cmapid == CMAP_GREYINV32) || 
      (cmapid == CMAP_GREY128) || (cmapid == CMAP_GREYINV128))  mdrw->GetGraphicAtt().SetColAtt(PI_Red);
 else mdrw->GetGraphicAtt().SetColAtt(PI_Turquoise);
-PIPixmap::SetColMapId(cmapid, revidx, false);
-if (refr) { xcurs =  ycurs = -1; }
-bool fgapp = false;
-if (refr && cmap->NCol() != ncolold) {
-  fgapp = true;  refr = false;
-}
-if (lut) lut->SetNCol(GetColMap()->NCol());
-if (refr) Refresh();
+PIPixmap::SetColMapId(cmapid, revidx, refr);
 if (zow)  zow->SetColMapId(cmapid, revidx, refr);
-if (gvw)  { 
-    if (cmap->NCol() != ncolold) { 
-    ComputeGloVPixmap();
-    SetGloVPixmap();
-  }
-  else  gvw->SetColMapId(cmapid, revidx, refr);
-}
+if (gvw)  gvw->SetColMapId(cmapid, revidx, refr);
 if (cmvw) cmvw->SetColMapId(cmapid, revidx, Lut()->Min(), Lut()->Max(), refr);
-if (fgapp)  Apply();
 return;
 }
@@ -806,8 +754,4 @@
 {
 if (img == NULL)  return;
-if (fgshowcmap>0)  {
-  cmpd.SetColMap(GetColMap());
-  cmpd.SetBornes(*Lut());
-}
 if (mw)  {  
   ComputePixmap();
@@ -1167,14 +1111,14 @@
 ywsz = YSize();
 
-img->ComputePixmap(lut, offx, offy, zoom, xwsz, ywsz, pixm);
+pixm = img->ComputePixmap(lut, offx, offy, zoom, xwsz, ywsz, pixm, &xspxm, &yspxm);
 int xw1, yw1, xw2, yw2;
-xw1 = (xwsz-pixm.XSize())/2;
+xw1 = (xwsz-xspxm)/2;
 if (xw1 < 0) xw1 = 0;
-yw1 = (ywsz-pixm.YSize())/2;
+yw1 = (ywsz-yspxm)/2;
 if (yw1 < 0) yw1 = 0;
-xw2 = pixm.XSize()+xw1;
-yw2 = pixm.YSize()+yw1;
+xw2 = xspxm+xw1;
+yw2 = yspxm+yw1;
 SetDefaultDrawRectangle(xw1, yw1, xw2, yw2, false);
-// printf("--DBG-- ComputePixmap() %d %d $ %d %d :: %d %d , %d %d \n", xwsz, ywsz, pixm.XSize(), pixm.YSize(), xw1, yw1, xw2, yw2);
+// printf("--DBG-- ComputePixmap() %d %d $ %d %d :: %d %d , %d %d \n", xwsz, ywsz, xspxm, yspxm, xw1, yw1, xw2, yw2);
 int x1,y1, x2,y2;
 ofx = xw1;  ofy = yw1;
@@ -1187,5 +1131,5 @@
 // printf("--DBG2-- ComputePixmap() %g %g  %g %g  \n", fx1, fx2, fy1, fy2);
 xcurs = ycurs = -1;
-SetPixmap(&pixm, true, xw1, yw1); 
+SetPixmap(pixm, xspxm, yspxm, true, xw1, yw1); 
 // Refresh();
 return; 
@@ -1230,7 +1174,7 @@
 if (lofy < 0)  lofy = 0;
 
-img->ComputePixmap(lut, lofx, lofy, zm, xwsz, ywsz, zpixm);
+zpixm = img->ComputePixmap(lut, lofx, lofy, zm, xwsz, ywsz, zpixm, &xszpxm, &yszpxm);
 zow->SetColMap(cmap, false);
-zow->SetPixmap(&zpixm); 
+zow->SetPixmap(zpixm, xszpxm, yszpxm); 
 zow->SetUserData((void *)this, 0);
 // zow->Refresh();
@@ -1259,6 +1203,6 @@
 zmgv = zmx;
 if (zmx > 1)  zmx = -zmx;
-img->ComputePixmap(lut, 0, 0, zmx, xwsz, ywsz, gpixm);
-// printf("DEBUG-ComputeGloVPixmap()  %d-%d , (%d,%d) , %d-%d \n", xwsz, ywsz, zmx, zmy, gpixm.XSize(), gpixm.YSize());
+gpixm = img->ComputePixmap(lut, 0, 0, zmx, xwsz, ywsz, gpixm, &xsgpxm, &ysgpxm);
+// printf("DEBUG-ComputeGloVPixmap()  %d-%d , (%d,%d) , %d-%d \n", xwsz, ywsz, zmx, zmy, xsgpxm, ysgpxm);
 return;
 }
@@ -1271,10 +1215,10 @@
 
 int xw1, yw1, xw2, yw2;
-xw1 = (gvw->XSize()-gpixm.XSize())/2;
+xw1 = (gvw->XSize()-xsgpxm)/2;
 if (xw1 < 0) xw1 = 0;
-yw1 = (gvw->YSize()-gpixm.YSize())/2;
+yw1 = (gvw->YSize()-ysgpxm)/2;
 if (yw1 < 0) yw1 = 0;
-xw2 = gpixm.XSize()+xw1;
-yw2 = gpixm.YSize()+yw1;
+xw2 = xsgpxm+xw1;
+yw2 = ysgpxm+yw1;
 
 if (zoom > 0) zm = zmgv*zoom;
@@ -1298,5 +1242,5 @@
 gvw->AddDrawer(gvdrw, xw1, yw1, xw2, yw2, false); 
 gvw->SetColMap(cmap, false);
-gvw->SetPixmap(&gpixm, true, xw1, yw1); 
+gvw->SetPixmap(gpixm, xsgpxm, ysgpxm, true, xw1, yw1); 
 gvw->SetUserData((void *)this, 0);
 gvw->SetMsg(Msg()+626);
@@ -1404,34 +1348,4 @@
 //printf("UpdateCuts()-DBG X: %d  -> %g  , Y: %d -> %g \n", cutarrx->Size(), cutarrx->Value(0),
 //       cutarry->Size(), cutarry->Value(0));
-}
-
-/* --Methode-- */
-void PIImage::UpdateCMapDrawer(int fgshow)
-{
-  if ((fgshow<0)||(fgshow>4))  fgshow=0;
-  if (fgshow==fgshowcmap) return;
-  fgshowcmap=fgshow;
-  switch (fgshowcmap ) {
-  case 0 :
-    RemoveDrawer(cmdid); 
-    break;
-  case 1 :
-    cmpd.SetHorizontal();
-    cmdid=AddDrawer(&cmpd, 0.10, 0.02, 0.90, 0.10, true, false);
-    break;
-  case 2 :
-    cmpd.SetVertical();
-    cmdid=AddDrawer(&cmpd, 0.90, 0.1, 0.98, 0.9, true, false);
-    break;
-  case 3 :
-    cmpd.SetHorizontal();
-    cmdid=AddDrawer(&cmpd, 0.10, 0.90, 0.90, 0.98, true, false);
-    break;
-  case 4 :
-    cmpd.SetVertical();
-    cmdid=AddDrawer(&cmpd, 0.02, 0.1, 0.10, 0.9, true, false);
-    break;   
-  } 
-  if (fgshowcmap>0) cmpd.GetGraphicAtt().SetColAtt(PI_Turquoise);
 }
 
Index: /trunk/SophyaPI/PI/piimage.h
===================================================================
--- /trunk/SophyaPI/PI/piimage.h	(revision 4076)
+++ /trunk/SophyaPI/PI/piimage.h	(revision 4077)
@@ -135,5 +135,4 @@
   void SetGloVPixmap();
   void UpdateCuts();
-  void UpdateCMapDrawer(int fgshow);
 
   void DrawCursor(PIGraphic* g);
@@ -155,5 +154,6 @@
   bool winovis;   // $CHECK$ Reza A enlever si possible 17/6/96
 // Tableau des pixels principal  
-  PIPixColIdx pixm;
+  unsigned char * pixm;
+  int xspxm, yspxm;
   LUT * lut;
   AutoLutType t_al;   // Si AutoLut et le type lors du dernier appel a SetLut()
@@ -164,15 +164,14 @@
   int zoom;
   PIPixmap * zow;
-  PIPixColIdx zpixm;
-// Fenetre pour vue globale de l'image   
+  unsigned char * zpixm;
+  int xszpxm, yszpxm;
+// Fenetre pour l'image entiere  
   int zmgv;
   PIPixmap * gvw;
-  PIPixColIdx gpixm;
+  unsigned char * gpixm;
+  int xsgpxm, ysgpxm;
   PIElDrawer* gvdrw;
 // Fenetre d'affichage du ColMap
   PICMapView* cmvw;
-  int fgshowcmap;  // 0: Pas de vue ColMap, 1: top, 2:right, 3:bottom, 4:left
-  PICMapDrawer cmpd;
-  int cmdid;
 // Fenetre/champ de texte
   PILabel * trtlb;
Index: /trunk/SophyaPI/PI/piimgtools.cc
===================================================================
--- /trunk/SophyaPI/PI/piimgtools.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/piimgtools.cc	(revision 4077)
@@ -99,9 +99,7 @@
 mOpt[0] = new PIOptMenu(this, "imglut-opt-1", 1.5*bsx, bsy, cpx, cpy);
 mOpt[0]->AppendItem("Linear", 1100);
-mOpt[0]->AppendItem("Log", 1101);
-mOpt[0]->AppendItem("Exp", 1102);
-mOpt[0]->AppendItem("Sqrt", 1103);
-mOpt[0]->AppendItem("Square", 1104);
-mOpt[0]->AppendItem("RGB", 1105);
+mOpt[0]->AppendItem("Log.", 1101);
+mOpt[0]->AppendItem("Sqrt", 1102);
+mOpt[0]->AppendItem("Square", 1103);
 mOpt[0]->SetValue(1100);
 mOpt[0]->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
@@ -176,7 +174,6 @@
 mCasc[1] = new PIMenu(mOptzc[0]->Menu(), "PIUniCol32");
 mCasc[2] = new PIMenu(mOptzc[0]->Menu(), "MIDAS-CMap");
-mCasc[3] = new PIMenu(mOptzc[0]->Menu(), "RGB-CMap");
-
-int nsct1,nsct2,nsct3,nsct4,nsct5;
+
+int nsct1,nsct2,nsct3,nsct4;
 //  D'abord les tables standard de PI  32 couleurs
 nsct1 = 5;   // Les 5 premieres tables
@@ -193,16 +190,12 @@
 mOptzc[0]->AppendPDMenu(mCasc[1]);
 //  Apres les tables importees de MIDAS
-nsct4 = PIColorMap::NumberStandardColorMaps()-6; // Les reste jusqu'a l'avant derniere
+nsct4 = PIColorMap::NumberStandardColorMaps()-2; // Les reste jusqu'a l'avant derniere
 for(kcc=nsct3; kcc<nsct4; kcc++) 
   mCasc[2]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
 mOptzc[0]->AppendPDMenu(mCasc[2]);
-nsct5 = PIColorMap::NumberStandardColorMaps()-4; // Les reste jusqu'aux tables RGB
-for(kcc=nsct4; kcc<nsct5; kcc++) 
-  mOptzc[0]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
-// Les tables de couleur RGB  ( RGB216, RGB512 , ... )
-for(kcc=nsct5; kcc<PIColorMap::NumberStandardColorMaps(); kcc++) 
-  mCasc[3]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
-mOptzc[0]->AppendPDMenu(mCasc[3]);
-  // On ajoute un CheckItem pour inverser les index de table de couleur
+// Les tables qui restent ( Col16 , ... )
+for(kcc=nsct4; kcc<PIColorMap::NumberStandardColorMaps(); kcc++) 
+mOptzc[0]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
+// On ajoute un CheckItem pour inverser les index de table de couleur
 mOptzc[0]->Menu()->AppendSeparator();
 mOptzc[0]->Menu()->AppendCheckItem("Reverse CMap", 299);
@@ -317,5 +310,5 @@
 for(i=0; i<3; i++)  delete mBut[i];
 delete mButR;
-for(i=0; i<4; i++)  delete mCasc[i];
+for(i=0; i<2; i++)  delete mCasc[i];
 for(i=0; i<5; i++)  delete mButsz[i];
 for(i=0; i<3; i++)  delete mButcax[i];
@@ -378,8 +371,6 @@
   if     ( (mpii->Lut())->Type() == kLutType_Lin )    mOpt[0]->SetValue(1100);
   else if( (mpii->Lut())->Type() == kLutType_Log )    mOpt[0]->SetValue(1101);
-  else if( (mpii->Lut())->Type() == kLutType_Exp )    mOpt[0]->SetValue(1102);
-  else if( (mpii->Lut())->Type() == kLutType_Sqrt )   mOpt[0]->SetValue(1103);
-  else if( (mpii->Lut())->Type() == kLutType_Square ) mOpt[0]->SetValue(1104);
-  else if( (mpii->Lut())->Type() == kLutType_RGB )    mOpt[0]->SetValue(1105);
+  else if( (mpii->Lut())->Type() == kLutType_Sqrt )   mOpt[0]->SetValue(1102);
+  else if( (mpii->Lut())->Type() == kLutType_Square ) mOpt[0]->SetValue(1103);
   else                                                mOpt[0]->SetValue(1100);
 }
@@ -397,5 +388,5 @@
 double min, max, del;
 int lauto, typ;
-int typlut[6] = {kLutType_Lin, kLutType_Log,  kLutType_Exp, kLutType_Sqrt, kLutType_Square, kLutType_RGB } ; 
+int typlut[4] = {kLutType_Lin, kLutType_Log, kLutType_Sqrt, kLutType_Square} ; 
 AutoLutType alts[13] = { AutoLut_No, 
 			 AutoLut_MeanSigma, AutoLut_MeanSigma, AutoLut_MeanSigma,
@@ -455,5 +446,5 @@
     if ((lauto < 0) || (lauto > 12))  lauto = 12;
     typ = mOpt[0]->GetValue() - 1100;
-    if ( (typ < 0) || (typ > 5) )  typ = 0;
+    if ( (typ < 0) || (typ > 3) )  typ = 0;
     (PIImage::CurrentPIImage())->SetLut(alts[lauto], min, max, typlut[typ], nsas[lauto]);
     if (msg == 2500) { 
Index: /trunk/SophyaPI/PI/pilistx.cc
===================================================================
--- /trunk/SophyaPI/PI/pilistx.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/pilistx.cc	(revision 4077)
@@ -116,5 +116,9 @@
 mNItem++;
 
-XmString xms = XmStringCreate(const_cast<char*>(item), const_cast<char*>(XmSTRING_DEFAULT_CHARSET));
+#if defined(__DECCXX) || defined(__KCC__) || defined(__aCC__)
+XmString xms = XmStringCreate(const_cast<char *>(item), XmSTRING_DEFAULT_CHARSET);
+#else
+XmString xms = XmStringCreate((char *)(item), XmSTRING_DEFAULT_CHARSET);
+#endif
 XmListAddItem(mlist, xms, 0);
 XmStringFree(xms);
Index: /trunk/SophyaPI/PI/pimenux.cc
===================================================================
--- /trunk/SophyaPI/PI/pimenux.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/pimenux.cc	(revision 4077)
@@ -386,5 +386,5 @@
   n=0;
   sprintf(acc,"Ctrl/%c", sc[0]);
-  xmstr = XmStringLtoRCreate(acc, const_cast<char*>(XmSTRING_DEFAULT_CHARSET));
+  xmstr = XmStringLtoRCreate(acc, XmSTRING_DEFAULT_CHARSET);
   XtSetArg(warg[n], XmNacceleratorText, xmstr); n++;
   sprintf(acc,"Ctrl<Key>%c", sc[0]);
Index: /trunk/SophyaPI/PI/pipixmapgen.cc
===================================================================
--- /trunk/SophyaPI/PI/pipixmapgen.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/pipixmapgen.cc	(revision 4077)
@@ -8,5 +8,4 @@
 #include "sopnamsp.h"
 #include "pipixmapgen.h"
-
 
 // --------- Methodes de la classe PIPixMap  ----------
@@ -44,6 +43,7 @@
 // long  kind() 
 //	Retourne le type ("=PIPixmap::ClassId")
-// void  SetPixmap(PIPixColIdx *pixidx, int sx, int sy, bool refr=true, int ox=0, int oy=0)
-//	Associe un tableau d'index de couleur "pixidx". (ox,oy)" définissent  l'offset d'affichage.
+// void  SetPixmap(unsigned char *pix, int sx, int sy, bool refr=true, int ox=0, int oy=0)
+//	Associe un tableau d'index "pix" de taille "sx * sy".
+//	(ox,oy)" définissent  l'offset d'affichage.
 //	Si "refr=true", la méthode "Refresh()" est appelée.
 //--
@@ -87,5 +87,5 @@
 {
 pixmap = NULL;
-fgownpmap = false;
+nx = ny = 0;
 ofx = ofy = 0;
 mPpos[0] = mPpos[0] = 0;
@@ -99,41 +99,21 @@
 {
 delete cmap;
-if (fgownpmap && pixmap) delete pixmap;
 }
 
 /* --Methode-- */
-void PIPixmapGen::SetPixmap(PIPixColIdx *pixidx, bool refr, int ox, int oy)
+void PIPixmapGen::SetPixmap(unsigned char *pix, int sx, int sy, bool refr, int ox, int oy)
 {
-if (fgownpmap && pixmap) delete pixmap;
-fgownpmap = false;
-pixmap = pixidx; 
-if (ox < 0)  ox = 0;
-if (oy < 0)  oy = 0;
-ofx = ox;  ofy = oy;
+pixmap = pix; 
+if (pixmap)
+  {
+  if (sx < 0)  sx = 0;
+  if (sy < 0)  sy = 0;
+  if (ox < 0)  ox = 0;
+  if (oy < 0)  oy = 0;
+  nx = sx; ny = sy;
+  ofx = ox;  ofy = oy;
+  }
+else { ofx = ofy = nx = ny = 0; }
 if (refr) Refresh();   
-}
-
-/* --Methode-- */
-void PIPixmapGen::SetRGBArray(PIPixRGBArray *rgba, CMapId cmapid, bool refr, int ox, int oy)
-{
-if (rgba == NULL) return;
-int quantum = 8;
-if (cmapid == CMAP_RGB216)  quantum = 6;
-else if (cmapid == CMAP_RGB4096) quantum = 16;
-else cmapid = CMAP_RGB512;
-SetColMapId(cmapid, false);
-PIPixColIdx * pixc = new PIPixColIdx;
-pixc->AllocateByte(rgba->XSize(), rgba->YSize());
-for(int j=0; j<rgba->YSize(); j++) 
-  for(int i=0; i<rgba->XSize(); i++) {
-  	PIPixRGB vv = (*rgba)(i,j);
-  	int r = (int)vv.red*quantum/256;
-  	int g = (int)vv.green*quantum/256;
-  	int b = (int)vv.blue*quantum/256;
-    pixc->GetShort(i,j) = (unsigned short)((b*quantum+g)*quantum+r);
-  }
-SetPixmap(pixc, refr, ox, oy);
-fgownpmap = true;
-return;  
 }
 
Index: /trunk/SophyaPI/PI/pipixmapgen.h
===================================================================
--- /trunk/SophyaPI/PI/pipixmapgen.h	(revision 4076)
+++ /trunk/SophyaPI/PI/pipixmapgen.h	(revision 4077)
@@ -9,8 +9,5 @@
 #include PICMAP_H
 
-#include "pipixutils.h"
-
 #include <list>
-
 
 class PIPixmapGen : public PIBaseWdg
@@ -25,7 +22,6 @@
   virtual long  kind() {return ClassId; }
 
-  virtual void  SetPixmap(PIPixColIdx *pixidx, bool refr=true, int ox=0, int oy=0);
-  virtual void  SetRGBArray(PIPixRGBArray *rgba, CMapId cmapid=CMAP_RGB512, 
-                            bool refr=true, int ox=0, int oy=0);
+  virtual void  SetPixmap(unsigned char *pix, int sx, int sy, 
+                          bool refr=true, int ox=0, int oy=0);
 
   virtual void  SetColMap(PIColorMap* cmp, bool refr=true);
@@ -43,7 +39,7 @@
 
 protected:
-  PIPixColIdx *pixmap;   // Pointeur d'objet PIPixCoIdx, tableau d'index de couleurs, peut etre NULL
-  bool fgownpmap;  // si true -> possede le pixmap et doit le deleter si besoin
-  int ofx, ofy;       // Offset d'affichage 
+  unsigned char *pixmap;
+  int nx, ny;
+  int ofx, ofy;
   PIColorMap* cmap;
 
Index: /trunk/SophyaPI/PI/pipixmapx.cc
===================================================================
--- /trunk/SophyaPI/PI/pipixmapx.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/pipixmapx.cc	(revision 4077)
@@ -7,7 +7,4 @@
 #include "sopnamsp.h"
 #include "pipixmapx.h"
-#include <iostream>
-
-using namespace std;
 
 static  GC    mygc;
@@ -34,37 +31,20 @@
 {
 int i,j;
-int nx = 0;
-int ny = 0;
-if (pixmap!=NULL) {
-  nx = pixmap->XSize();
-  if (nx > XSize())  nx = XSize();
-  ny = pixmap->YSize();
-  if (ny > YSize())  ny = YSize();
-  if (pixmap->BytePointer()!=NULL) {
-    unsigned char *pp = pixmap->BytePointer();
-    for(j=0; j<ny; j++) {
-      pp = pixmap->BytePointer()+j*pixmap->XSize();
-      for(i=0; i<nx; i++)
-        { XPutPixel(myximg, i, j, cmap->Color(*pp) );  pp++; }
-      }
-  }
-  else if (pixmap->ShortPointer()!=NULL) {
-    unsigned short *pp = pixmap->ShortPointer();
-    for(j=0; j<ny; j++) {
-      pp = pixmap->ShortPointer()+j*pixmap->XSize();
-      for(i=0; i<nx; i++)  
-        { XPutPixel(myximg, i, j, cmap->Color(*pp) );  pp++; }
+unsigned char *pp;
+
+if (pixmap)
+  {
+  for(j=0; j<ny; j++)
+    {
+    pp = pixmap+j*nx;
+    for(i=0; i<nx; i++)
+      { XPutPixel(myximg, i, j, cmap->Color(*pp) );  pp++; }
     }
   }
-}
-/* ----- On peut laisser le reste - ce n'est pas utilise dans le Draw
-// On remplit le restant 
-for(j=0; j<YSize(); j++)
+
+for(j=ny; j<YSize(); j++)
   for(i=nx; i<XSize(); i++)
-       XPutPixel(myximg, i, j, 0 );
-for(j=ny; j<YSize(); j++)
-  for(i=0; i<XSize(); i++)
      XPutPixel(myximg, i, j, 0 );
-------- */
+
 PIBaseWdgX::Refresh();
 }
@@ -86,5 +66,5 @@
 if (!g) return; 
 if (g->kind() == PI_PSFileGraphics ) {
-    g->DrawPixmap(ofx, ofy, pixmap, cmap);
+    g->DrawPixmap(ofx, ofy, pixmap, nx, ny, cmap);
     //  Il faut faire quelque chose Sinon ??! 
   }
@@ -98,18 +78,13 @@
 
 if (!g) return; 
+if ((myximg == NULL) || (cmap == NULL)) return;
 
 if (g->kind() == PI_PSFileGraphics ) {
-  g->DrawPixmap(ofx, ofy, (*pixmap), cmap);
+  if (pixmap) g->DrawPixmap(ofx, ofy, pixmap, nx, ny, cmap);
   return;
   }
-  
 
 Window xw = XtWindow(XtWdg());
 Display * mdsp = PIXDisplay();
-
-if ((myximg == NULL) || (cmap == NULL) || (pixmap == NULL) ||
-    (pixmap->XSize()<=0) || (pixmap->YSize()<=0) ) {
-  XClearArea(mdsp, xw, x0, y0, dx, dy, False);  return; 
-}
 
 int mx, my, ox, oy;
@@ -117,7 +92,5 @@
 if (x0 < 0)  x0 = 0;
 if (y0 < 0)  y0 = 0;
-
-mx = pixmap->XSize()+ofx;   my = pixmap->YSize()+ofy;
-
+mx = nx+ofx;   my = ny+ofy;
 if (dx > (XSize()-x0)) dx = XSize()-x0;
 if (dy > (YSize()-y0)) dy = YSize()-y0;
@@ -128,4 +101,5 @@
 
 ox = oy = 0;  
+
 if (ofx > x0)
   { XClearArea(mdsp, xw, x0, y0, ofx-x0, dy, False);   
@@ -141,26 +115,5 @@
 if (my < (y0+dy))
   { XClearArea(mdsp, xw, x0, my, dx, y0+dy-my, False);  dy = my-y0; }
-
-/*
-if (ofx > x0)
-  XClearArea(mdsp, xw, x0, y0, ofx-x0, dy, False);   
-if (ofy > y0)
-  XClearArea(mdsp, xw, x0, y0, dx, ofy-y0, False);  
  
-if (mx < (x0+dx))
-  XClearArea(mdsp, xw, mx, y0, x0+dx-mx, dy, False); 
-if (my < (y0+dy))
-  XClearArea(mdsp, xw, x0, my, dx, y0+dy-my, False);  
-
-if (ofx > x0)
-  { dx -= (ofx-x0);  x0 = ofx;  ox = 0; }
-else  ox = x0-ofx;
-if (ofy > y0)
-  { dy -= (ofy-y0);  y0 = ofy;  oy = 0; }
-else  oy = y0-ofy;
-if (mx < (x0+dx))  dx = mx-x0;
-if (my < (y0+dy))  dy = my-y0;
-*/
-  
 XPutImage(mdsp, xw, mygc, myximg, ox, oy, x0, y0, dx, dy);
 XFlush(mdsp);
Index: /trunk/SophyaPI/PI/piscdrawwdg.cc
===================================================================
--- /trunk/SophyaPI/PI/piscdrawwdg.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/piscdrawwdg.cc	(revision 4077)
@@ -13,5 +13,7 @@
 #include "piaxestools.h"
 
-#include "ucckprot.h"
+#define PETIT_DBLE 1.e-100
+#define PREC_DBLE  1.e-16
+
 
 //++
@@ -178,6 +180,13 @@
                        int axrl, int ayud, bool tmp)
 {
-  UC_CheckMinMaxDiff(xmin,xmax);
-  UC_CheckMinMaxDiff(ymin,ymax);
+//  if (xmax <= xmin || ymax <= ymin) {
+//    cerr << "PIScDrawWdg::SetLimits() Error - xmax <= xmin or ymax <= ymin !" << endl;
+//    return; 
+//    }
+  double xym;
+  xym = fabs(xmax+xmin); xym = (xym > PETIT_DBLE) ? xym : PETIT_DBLE;
+  if ((xmax-xmin)/xym < PREC_DBLE) { xmin = xmin - PREC_DBLE/2.*xym;  xmax = xmin + PREC_DBLE*xym; }
+  xym = fabs(ymax+ymin); xym = (xym > PETIT_DBLE) ? xym : PETIT_DBLE;
+  if ((ymax-ymin)/xym < PREC_DBLE) { ymin = ymin - PREC_DBLE/2.*xym;  ymax = ymin + PREC_DBLE*xym; }
 
   SetDefaultDrawerLimits(xmin, xmax, ymin, ymax, axrl, ayud);
@@ -239,18 +248,4 @@
   bool fglogy = isLogScaleY();
 
-  // Flag declenchant SetLimits
-  bool fgsaxel = false;
-  // Limites et sens d'axe
-  double xmin = XMin();
-  double ymin = YMin();
-  double xmax = XMax();
-  double ymax = YMax();
-  int axrl = kAxeDirLtoR;
-  int ayud = kAxeDirDownUp;
-  int xac, yac;
-  GetAxesConfig(xac, yac);
-  if (xac & kAxeDirRtoL) axrl = kAxeDirRtoL;
-  if (yac & kAxeDirUpDown) ayud = kAxeDirUpDown;
-
   for( k=0; k<opt.size(); k++ ) {
     string opts = opt[k];
@@ -264,6 +259,10 @@
     // Limites en x,y
     if (opts.substr(0,9) == "xylimits=") {
+      double xmin = XMin();
+      double ymin = YMin();
+      double xmax = XMax();
+      double ymax = YMax();
       sscanf(opts.substr(9).c_str(),"%lg,%lg,%lg,%lg",&xmin, &xmax,&ymin,&ymax);
-      fgsaxel = true;
+      SetLimits(xmin, xmax, ymin, ymax);
       continue;
     }
@@ -293,22 +292,6 @@
       continue;
     }
-    if ((opts == "revax") || (opts == "axerl") ) {
-      fgsaxel = true;  axrl = kAxeDirRtoL;
-      continue;
-    }
-    if ((opts == "revay") || (opts == "axeud") ) {
-      fgsaxel = true;  ayud = kAxeDirUpDown;
-      continue;
-    }
-    if (opts == "axelr") {
-      fgsaxel = true;  axrl = kAxeDirLtoR;
-      continue;
-    }
-    if (opts == "axedu") {
-      fgsaxel = true;  ayud = kAxeDirDownUp;
-      continue;
-    }
-
-// Les autres attributs d'axes (stdaxes boxaxesgrid ...) sont decodes par PIElDrawer
+
+// Les attributs d'axes (stdaxes boxaxesgrid ...) sont decodes par PIElDrawer
 
     ndec--;
@@ -316,5 +299,4 @@
   }  
 
-  if (fgsaxel)  SetLimits(xmin, xmax, ymin, ymax, axrl, ayud);
   if (fglinlog) SetLogScale(fglogx, fglogy);
 
Index: /trunk/SophyaPI/PI/pistdwdgx.cc
===================================================================
--- /trunk/SophyaPI/PI/pistdwdgx.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/pistdwdgx.cc	(revision 4077)
@@ -51,5 +51,5 @@
 {
 XmString xmstr;
-xmstr = XmStringLtoRCreate(const_cast<char*>(lab.c_str()), const_cast<char*>(XmSTRING_DEFAULT_CHARSET));
+xmstr = XmStringLtoRCreate((char *)lab.c_str(), XmSTRING_DEFAULT_CHARSET);
 int n=0;
 Arg warg[2];
@@ -149,5 +149,5 @@
 {
 XmString xmstr;
-xmstr = XmStringLtoRCreate(const_cast<char*>(lab.c_str()), const_cast<char*>(XmSTRING_DEFAULT_CHARSET));
+xmstr = XmStringLtoRCreate((char *)lab.c_str(), XmSTRING_DEFAULT_CHARSET);
 int n=0;
 Arg warg[2];
Index: /trunk/SophyaPI/PI/pitherm.cc
===================================================================
--- /trunk/SophyaPI/PI/pitherm.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/pitherm.cc	(revision 4077)
@@ -24,5 +24,5 @@
 //--
 //++
-//  PIThermometer(PIContainerGen *par, const char *nom, int sx=256, int sy=10, int px=0, int py=0)
+//  PIThermometer(PIContainerGen *par, char *nom, int sx=256, int sy=10, int px=0, int py=0)
 //	Constructeur - Le choix d'affichage (vertical ou horizontal) dépend
 //	du rapport des tailles "sx", "sy"
@@ -31,5 +31,5 @@
 
 /* --Methode-- */
-PIThermometer::PIThermometer(PIContainerGen *par, const char *nom,
+PIThermometer::PIThermometer(PIContainerGen *par, char *nom,
                        int sx, int sy, int px, int py) 
 : PIBaseWdg(par, nom, sx, sy, px, py)
@@ -139,5 +139,4 @@
 void PIThermometer::Draw(PIGraphicGen* g, int /*x0*/, int /*y0*/, int /*dx*/, int /*dy*/)
 {
-  if (!IsVisible())  return;
   double delta = (max_-min_);
   if (delta < 1.e-39) delta = 1.e-39;
Index: /trunk/SophyaPI/PI/pitherm.h
===================================================================
--- /trunk/SophyaPI/PI/pitherm.h	(revision 4076)
+++ /trunk/SophyaPI/PI/pitherm.h	(revision 4077)
@@ -16,5 +16,5 @@
   enum {ClassId = 5220};
 
-                  PIThermometer(PIContainerGen *par, const char *nom,
+                  PIThermometer(PIContainerGen *par, char *nom,
                                 int sx=256, int sy=10, int px=0, int py=0);
   virtual         ~PIThermometer();
Index: /trunk/SophyaPI/PI/piversion.h
===================================================================
--- /trunk/SophyaPI/PI/piversion.h	(revision 4076)
+++ /trunk/SophyaPI/PI/piversion.h	(revision 4077)
@@ -2,5 +2,5 @@
 #define PIVERSION_H_SEEN
 
-#define PI_VERSIONNUMBER  4.40
+#define PI_VERSIONNUMBER  4.11
 
 #endif
Index: /trunk/SophyaPI/PI/piwdggen.cc
===================================================================
--- /trunk/SophyaPI/PI/piwdggen.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/piwdggen.cc	(revision 4077)
@@ -57,4 +57,7 @@
 //--
 //++
+// void  PSPrint(PSFile *psf, int ofx=0, int ofy=0)
+//	Méthode virtuelle qui doit être redéfinie pour chacune des classes filles.
+//	produit une représentation graphique de l'objet en Postscript.
 // SetSize(int sx, int sy)
 //	Modifie la taille de l'objet.
@@ -178,16 +181,4 @@
 // int  UserFlag()
 //	Renvoie la valeur "int" user de l'objet.
-//--
-
-//++
-// Titre	Export postscript et format RGB
-//--
-//++
-// void  PSPrint(PSFile *psf, int ofx=0, int ofy=0)
-//	Méthode virtuelle qui doit être redéfinie pour chacune des classes filles.
-//	produit une représentation graphique de l'objet en Postscript.
-// void  ExportToRGB(PIPixRGBArray & rgba)
-//	Méthode virtuelle qui doit être redéfinie pour chaque architecture.
-//	Remplit un tableau PIPixRGBArray le contenu pixels du widget en couleurs RGB. 
 //--
 
@@ -318,10 +309,4 @@
 }
 
-/* --Methode-- */
-void PIWdgGen::ExportToRGB(PIPixRGBArray & rgba)
-{
-return;
-}
-
 //++
 // Titre	Gestion des Draw/Event Handler
Index: /trunk/SophyaPI/PI/piwdggen.h
===================================================================
--- /trunk/SophyaPI/PI/piwdggen.h	(revision 4076)
+++ /trunk/SophyaPI/PI/piwdggen.h	(revision 4077)
@@ -10,5 +10,4 @@
 #include "pimsghandler.h"
 #include "picolist.h"
-#include "pipixutils.h"
 
 #include <string>
@@ -108,10 +107,6 @@
   virtual bool           IfSensitive()=0;
 
-//  Pour exporter le contenu d'un widget (dessin vectoriel) en postscript
   virtual void           PSPrint(PSFile *psf, int ofx=0, int ofy=0,
 				 double scale_x=1., double scale_y=1.);
-// Pour exporter le tableau des pixels du widget en classe  PIPixRGBArray
-// L'implementation par defaut ne fait rien 
-  virtual void           ExportToRGB(PIPixRGBArray & rgba);
 
 //  Gestion de copier-coller
